## com.icl.saxon.expr
Class SingletonComparison

    java.lang.Object
      |
      +--com.icl.saxon.expr.Expression
            |
            +--com.icl.saxon.expr.SingletonComparison

public class SingletonComparison
extends Expression

Singleton Comparison: A Relational Expression that compares a singleton node-set with a string or numeric value for equals, not-equals, greater-than or less-than.

Field Summary

Fields inherited from class com.icl.saxon.expr.Expression
`staticContext`

Constructor Summary
`SingletonComparison(SingletonExpression p1, int op, Value p2)`

Method Summary
`void` `display(int level)` Diagnostic print of expression structure
`Value` `evaluate(Context c)` Evaluate the expression in a given context
`boolean` `evaluateAsBoolean(Context c)` Evaluate the expression in a given context
`int` `getDataType()` Determine the data type of the expression, if possible
`int` `getDependencies()` Determine which aspects of the context the expression depends on.
`Expression` `reduce(int dependencies, Context context)` Perform a partial evaluation of the expression, by eliminating specified dependencies on the context.
`Expression` `simplify()` Simplify an expression

Methods inherited from class com.icl.saxon.expr.Expression
`containsReferences, enumerate, evaluateAsNodeSet, evaluateAsNumber, evaluateAsString, getStaticContext, indent, isContextDocumentNodeSet, make, outputStringValue, setStaticContext, usesCurrent`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SingletonComparison

    public SingletonComparison(SingletonExpression p1,
                               int op,
                               Value p2)

Method Detail

### simplify

    public Expression simplify()
                        throws XPathException

  Simplify an expression

  Overrides:
    `simplify` in class `Expression`
  Returns:
    the simplified expression
    `XPathException`

### evaluate

    public Value evaluate(Context c)
                   throws XPathException

  Evaluate the expression in a given context

  Specified by:
    `evaluate` in class `Expression`
  Parameters:
    `c` - the given context for evaluation
  Returns:
    a BooleanValue representing the result of the comparison of the two operands
    `XPathException`

### evaluateAsBoolean

    public boolean evaluateAsBoolean(Context c)
                              throws XPathException

  Evaluate the expression in a given context

  Overrides:
    `evaluateAsBoolean` in class `Expression`
  Parameters:
    `c` - the given context for evaluation
  Returns:
    a boolean representing the result of the numeric comparison of the two operands
    `XPathException`

### getDataType

    public int getDataType()

  Determine the data type of the expression, if possible

  Specified by:
    `getDataType` in class `Expression`
  Returns:
    Value.BOOLEAN

### getDependencies

    public int getDependencies()

  Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as Context.VARIABLES and Context.CURRENT_NODE

  Specified by:
    `getDependencies` in class `Expression`

### reduce

    public Expression reduce(int dependencies,
                             Context context)
                      throws XPathException

  Perform a partial evaluation of the expression, by eliminating specified dependencies on the context.

  Specified by:
    `reduce` in class `Expression`
  Parameters:
    `dependencies` - The dependencies to be removed
    `context` - The context to be used for the partial evaluation
  Returns:
    a new expression that does not have any of the specified dependencies
    `XPathException`

### display

    public void display(int level)

  Diagnostic print of expression structure

  Specified by:
    `display` in class `Expression`